/*
*  aboutdlgs.cpp
*
*  Copyright (C) 2010 Richard Christman 
*
*  This file is part of QuickSilver Lite.
*
*  QuickSilver Lite is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver Lite, or any covered work, by linking or 
*  combining it with CodeGear VCL (or a modified version of that library), 
*  containing parts covered by the terms of CodeGear's license, the licensors 
*  of QuickSilver Lite grant you additional permission to convey the 
*  resulting work.
*
*/

//---------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "aboutdlgs.h"
#include "utility.h"
#include "global.h"
#ifdef QS2
#include "qsver.h"
#else
#include "qslver.h"
#endif
#include "licensedlgs.h"
#include "mixmaster.h"
//---------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TAboutBox *AboutBox;
//---------------------------------------------------------------------

void __fastcall ShowAboutBox(TForm *Owner)
{
   TAboutBox *aboutbox = new TAboutBox(Owner);
   aboutbox->ShowModal();
   delete aboutbox;
}
//---------------------------------------------------------------------

__fastcall TAboutBox::TAboutBox(TComponent* AOwner)
	: TForm(AOwner)
{
   AnsiString mixver = MixmasterVersion();
   int x; while ((x = mixver.Pos("\t")) > 0)
   {
	  mixver.Delete(x, 1);
	  mixver.Insert("  ", x);
   }
   ProgramIcon->Picture->Icon->Handle = LoadImage(HInstance,
	  "MAINICON", IMAGE_ICON, 48, 48, LR_SHARED);
   ProductName->Caption = QuickSilverVersion();
   Mixmaster->Caption = mixver;
}
//---------------------------------------------------------------------

void __fastcall TAboutBox::LicenseClick(TObject *Sender)
{
   if (!FileExists(AppLicense()))
   {
	  MsgBox(this,
		 "Sorry to say, the license file, " + ExtractFileName(AppLicense()) + ", "
		 "is missing from my home   \n"
		 "directory. Reinstalling the program should fix the problem.",
		  MT_ERROR, MB_OK);
	  return;
   }
   //Exec32("notepad.exe " + AppDir() + "copying.txt");
   ShowLicense(this);
}
//---------------------------------------------------------------------------

