/*
*  dsadlgs.cpp 
*
*  Copyright (C) 2010 Richard Christman 
*
*  This file is part of QuickSilver Lite.
*
*  QuickSilver Lite is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver Lite, or any covered work, by linking or 
*  combining it with CodeGear VCL (or a modified version of that library), 
*  containing parts covered by the terms of CodeGear's license, the licensors 
*  of QuickSilver Lite grant you additional permission to convey the 
*  resulting work.
*
*/

//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "dsadlgs.h"
#include "global.h"
#include "utility.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TDSADlg *DSADlg;
//---------------------------------------------------------------------------

int __fastcall DSABox(TForm *Owner, const AnsiString &DlgName, const AnsiString &Text,
   const AnsiString &Caption, UINT Type, int Width, int Height)
{
   TIniFile *ini = new TIniFile(AppIni());
   if (ini->ReadBool("dontshow", DlgName, false))
   {
	  delete ini;
      return IDOK;
   }

   TDSADlg *dsadlg = new TDSADlg(Owner, Text, Caption, Type, Width, Height);
   dsadlg->ShowModal();
   int IDRET = dsadlg->ModalResult;
   if (dsadlg->DontBox->Checked)
      ini->WriteBool("dontshow", DlgName, true);
   delete dsadlg;

   delete ini;
   return IDRET;
}
//---------------------------------------------------------------------------

__fastcall TDSADlg::TDSADlg(TComponent* Owner)
        : TForm(Owner)
{
   PopupParent = (TForm*)Owner;
}
//---------------------------------------------------------------------------

__fastcall TDSADlg::TDSADlg(TComponent* Owner, const AnsiString &Text,
   const AnsiString &caption, UINT Type, int width, int height)
   : TForm(Owner)
{
   PopupParent = (TForm*)Owner;
   TIniFile *ini = new TIniFile(AppIni());
   AssignFont(Font, ini->ReadString("settings", "dialogfont", OptsDefDialogFont));
   delete ini;
   Message->Caption = Text;
   if (Type == MB_OK)
   {
      OkBtn->Left = Width - 90;
      OkBtn->Top = Height - 40;
      CancelBtn->Hide();
   }
   Caption = caption;
   if (height)
      Height = height;
   if (width)
      Width = width;
}
//---------------------------------------------------------------------------
