/*
*  follow2postdlgs.cpp 
*
*  Copyright (C) 2010 Richard Christman 
*
*  This file is part of QuickSilver Lite.
*
*  QuickSilver Lite is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver Lite, or any covered work, by linking or 
*  combining it with CodeGear VCL (or a modified version of that library), 
*  containing parts covered by the terms of CodeGear's license, the licensors 
*  of QuickSilver Lite grant you additional permission to convey the 
*  resulting work.
*
*/

//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include <inifiles.hpp>

#include "follow2postdlgs.h"
#include "utility.h"
#include "global.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
//TFollow2PostDlg *Follow2PostDlg;
//---------------------------------------------------------------------------

bool __fastcall FollowupToPoster(TForm *Owner, bool &reply, bool &follow)
{
   TFollow2PostDlg *follow2postdlg = new TFollow2PostDlg(Owner);
   follow2postdlg->ShowModal();
   bool ok = follow2postdlg->ModalResult==mrOk;
   if (ok)
   {
      follow = follow2postdlg->FollowBox->Checked;
      reply = follow2postdlg->ReplyBox->Checked;
   }
   delete follow2postdlg;
   return ok;
}
//---------------------------------------------------------------------------

__fastcall TFollow2PostDlg::TFollow2PostDlg(TComponent* Owner)
        : TForm(Owner)
{
   PopupParent = (TForm*)Owner;
   TIniFile *ini = new TIniFile(AppIni());
   AssignFont(Font, ini->ReadString("settings", "dialogfont", OptsDefDialogFont));
   delete ini;
}
//---------------------------------------------------------------------------
