/*
*  mimeencs.h 
*
*  Copyright (C) 2010 Richard Christman 
*
*  This file is part of QuickSilver Lite.
*
*  QuickSilver Lite is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver Lite, or any covered work, by linking or 
*  combining it with CodeGear VCL (or a modified version of that library), 
*  containing parts covered by the terms of CodeGear's license, the licensors 
*  of QuickSilver Lite grant you additional permission to convey the 
*  resulting work.
*
*/

//---------------------------------------------------------------------------
#ifndef mimeencsH
#define mimeencsH
//---------------------------------------------------------------------------

bool __fastcall EncodeMIMEAttachments(TForm *Owner, TStrings *Message, bool Inline);
//bool __fastcall EncodeMIMEAttachments(TStrings *Message, bool Inline);
bool __fastcall HasAttachments(TStrings *message);

class TMIMEencoder : public TObject
{
public:
   int status;
   bool ok, Inline;
   TStrings *Message;
   TStringList *Inlines;
   TStringList *Filenames;
   AnsiString MimeBoundary;
   TForm *Owner;

   __fastcall TMIMEencoder(TForm *Owner, TStrings *Message, bool Inline);
   __fastcall~TMIMEencoder();
   bool __fastcall EncodeAttachments();
   bool __fastcall AttachFilesInline(TStrings *filenames);
   void __fastcall AttachFile(const AnsiString &Filename, const AnsiString &encodemethod);
   bool __fastcall AttachInlineBase64(const AnsiString &filename, TStrings *message);
   bool __fastcall AttachInlineUU(AnsiString filename, TStrings *message);
   void __fastcall Base64Encode(const AnsiString &Filename, TStrings *message);
   void __fastcall UUEncode(AnsiString Filename, TStrings *message);
   AnsiString __fastcall GetContentType(const AnsiString &Filename);
   void __fastcall DeleteHeader(const AnsiString &Header);
   int  __fastcall GetAttachmentNames();
   int  __fastcall EOH();

   TStream* __fastcall new_AttachmentStream(const AnsiString &Filename);
};

// encoder status return codes
const int statNotMimeMessage = -100;
const int statMimeFileOpenError = -101;
const int statMimeOk = 0;
const int statMimeCancel = -1;
const int statMimeBadFilename = -3;
const int statMimeBadEncodeMethod = -4;
const int statMimeBadDecodeMethod = -5;
const int statMimeDecodeError = -6;

//---------------------------------------------------------------------------
#endif
