/*
*  pgpcpassdlgs.h 
*
*  Copyright (C) 2010 Richard Christman 
*
*  This file is part of QuickSilver Lite.
*
*  QuickSilver Lite is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver Lite, or any covered work, by linking or 
*  combining it with CodeGear VCL (or a modified version of that library), 
*  containing parts covered by the terms of CodeGear's license, the licensors 
*  of QuickSilver Lite grant you additional permission to convey the 
*  resulting work.
*
*/

//---------------------------------------------------------------------------

#ifndef pgpcpassdlgsH
#define pgpcpassdlgsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------

AnsiString __fastcall GetCEncryptionPassword(TForm *Owner);
AnsiString __fastcall GetSecureModePassphrase(TForm *Owner);

class TPGPcpassDlg : public TForm
{
__published:	// IDE-managed Components
        TLabel *Label1;
        TButton *OkBtn;
        TButton *CancelBtn;
        TLabel *Label2;
        TMemo *Confirm;
        TMemo *Phrase;
        TCheckBox *HideBox;
        TGroupBox *QualityBox;
        TProgressBar *ProgressBar1;
	TBevel *Bevel1;
        void __fastcall HideBoxClick(TObject *Sender);
        void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
        void __fastcall PhraseChange(TObject *Sender);
private:	// User declarations
public:		// User declarations
        int mode, minpasslen;
        TColor EditColor;
		__fastcall TPGPcpassDlg(TComponent* Owner);
		__fastcall virtual ~TPGPcpassDlg();
};

const int pmEncrypt = 0;
const int pmDecrypt = 1;
//---------------------------------------------------------------------------
//extern PACKAGE TPGPcpassDlg *PGPcpassDlg;
//---------------------------------------------------------------------------
#endif
