//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
#include <printers.hpp>

#include "PrintDlgs.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TPrintingDlg *PrintingDlg;
#define WAITMSG "  Wait..."
#define PRNTMSG "  Printing..."
//---------------------------------------------------------------------------

void __fastcall PrintMessage(TForm *Owner, TRichEdit *Editor, const AnsiString &Title,
   const AnsiString &Caption)
{
   PrintingDlg = new TPrintingDlg(Owner);
   PrintingDlg->Lines->Add(Title);
   PrintingDlg->Lines->Add(FormatDateTime("mmmm d, yyyy", Date()));
   PrintingDlg->Lines->Add("");
   PrintingDlg->Lines->AddStrings(Editor->Lines);
   PrintingDlg->Font = Editor->Font;
   PrintingDlg->Caption = Caption;
   PrintingDlg->ShowModal();
   delete PrintingDlg;
}
//---------------------------------------------------------------------------

void __fastcall PrintPage(TForm *Owner, TListBox *Page, const AnsiString &Title,
   const AnsiString &Caption)
{
   PrintingDlg = new TPrintingDlg(Owner);
   PrintingDlg->Lines->Add(Title);
   PrintingDlg->Lines->Add(FormatDateTime("mmmm d, yyyy", Date()));
   PrintingDlg->Lines->Add("");
   PrintingDlg->Lines->AddStrings(Page->Items);
   PrintingDlg->Font = Page->Font;
   PrintingDlg->Caption = Caption;
   PrintingDlg->ShowModal();
   delete PrintingDlg;
}
//---------------------------------------------------------------------------

void __fastcall PrintList(TForm *Owner, TStrings *List, TFont *Font,
   const AnsiString &Caption, bool Portrait)
{
   PrintingDlg = new TPrintingDlg(Owner);
   PrintingDlg->Font = Owner->Font;
   //PrintingDlg->Lines->Add(Title);
   //PrintingDlg->Lines->Add(FormatDateTime("mmmm d, yyyy", Date()));
   //PrintingDlg->Lines->Add("");
   PrintingDlg->Lines->AddStrings(List);
   PrintingDlg->Font = Font;
   PrintingDlg->Caption = Caption;
   PrintingDlg->Portrait = Portrait;
   PrintingDlg->ShowModal();
   delete PrintingDlg;
}
//---------------------------------------------------------------------------
__fastcall TPrintingDlg::TPrintingDlg(TComponent* Owner)
	: TForm(Owner)
{
   // initialize
   Lines = new TStringList();
   msg->Caption = WAITMSG;
   Cancelled = false;
   Printing = false;
   Portrait = true;
}
//---------------------------------------------------------------------------
void __fastcall TPrintingDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrOk) Printer()->EndDoc(); else Printer()->Abort();
   Timer1->Enabled = false;
   delete Lines;
}
//---------------------------------------------------------------------------
void __fastcall TPrintingDlg::FormShow(TObject *Sender)
{
   Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TPrintingDlg::Timer1Timer(TObject *Sender)
{
   if (msg->Caption==WAITMSG) msg->Caption = ""; else
   if (msg->Caption=="") msg->Caption=PRNTMSG; else msg->Caption="";
   if (!Printing) PrintLines();
}
//---------------------------------------------------------------------------
void __fastcall TPrintingDlg::PrintLines()
{
   AnsiString pageStr;
   int i,page,xpos,ypos,xpag,ypag;
   TCanvas *canvas = Printer()->Canvas;
   int pagewidth = Printer()->PageWidth;
   int pageheight = Printer()->PageHeight;

   Printing = true;
   Printer()->Orientation = Portrait ? poPortrait : poLandscape;
   Printer()->BeginDoc();
   Printer()->Canvas->Font->Name = Font->Name;
   Printer()->Canvas->Font->Size = Font->Size;
   page = 1;
   xpos = lmargin;
   ypos = tmargin;

   for (i=0; i<Lines->Count; i++)
   {
      Application->ProcessMessages();
      if (Cancelled) break;

      if (ypos==tmargin)
      {
         if (Lines->Strings[i].IsEmpty()) continue;

         pageStr = "Page "+String(page);
         xpag = (pagewidth/2)-(canvas->TextWidth(pageStr)/2);
         ypag = pageheight-(bmargin/2);
         canvas->TextOut(xpag,ypag,pageStr);
      }

      canvas->TextOut(xpos,ypos,Lines->Strings[i]);
      ypos = ypos+canvas->TextHeight("Yy")+between;
      if (ypos>pageheight-bmargin)
      {
         ypos = tmargin;
         Printer()->NewPage();
         page++;
      }
   }

   ModalResult = Cancelled ? mrCancel : mrOk;
   Timer1->Enabled = false;
   msg->Caption = "Job Complete!";
   CancelBtn->Enabled = false;
   Application->ProcessMessages();
   Sleep(500);
}
//---------------------------------------------------------------------------
void __fastcall TPrintingDlg::CancelBtnClick(TObject *Sender)
{
   Cancelled = true;
}
//---------------------------------------------------------------------------
